// $Id: CardinalityQIndication.java,v 1.4 2002/08/05 19:03:09 drager Exp $

package org.daml.validator.indications;

import com.hp.hpl.mesa.rdf.jena.model.*;
import java.util.*;

/**
 * Indication used for cardinalityQ restriction violations.
 */
public class CardinalityQIndication extends RestrictionIndication {
    
    public static int defaultLevel = Indication.ERROR;

    public CardinalityQIndication(org.daml.validator.model.DAMLModelImpl.Node instance,
				  org.daml.validator.model.DAMLModelImpl.Node onClass,
				  org.daml.validator.model.DAMLModelImpl.Restriction restriction,
				  java.util.Collection statements)
    {
	super(instance, onClass, restriction, statements);
	level = defaultLevel;
	type = "Qualified Cardinality Violation";
    }
	

    public String getMessage()
    {
	String m = "";
	m += "Resource "+instance+" violates the cardinality restriction on class "+onClass+" for property "+restriction.onProperty+" to qualified class "+restriction.hasClassQ+".  ";
	int size = statements.size();
	m += "Resource has "+statements.size()+" statements with this property.  ";
	if ((restriction.minCardinalityQ >= 0) && (size < restriction.minCardinalityQ)) {
	    m += "Minimum cardinality is "+restriction.minCardinalityQ+".  ";
	}
	if ((restriction.maxCardinalityQ >= 0) && (size > restriction.maxCardinalityQ)) {
	    m += "Maximum cardinality is "+restriction.maxCardinalityQ+".  ";
	}
	return(m);
    }

    /*
    public String getLocation()
    {
	return(getLocation(statements));
    }

    public String getLocationXML()
	throws RDFException
    {
	return(getLocationXML(statements));
    }
    */

}
