// $Id: HasValueIndication.java,v 1.5 2002/08/05 19:03:09 drager Exp $

package org.daml.validator.indications;

import com.hp.hpl.mesa.rdf.jena.model.*;
import java.util.*;

/**
 * Indication used for cardinality restriction violations.
 */
public class HasValueIndication extends RestrictionIndication {
    
    public static int defaultLevel = Indication.ERROR;

    public HasValueIndication(org.daml.validator.model.DAMLModelImpl.Node instance,
			      org.daml.validator.model.DAMLModelImpl.Node onClass,
			      org.daml.validator.model.DAMLModelImpl.Restriction restriction,
			      java.util.Collection statements)
    {
	super(instance, onClass, restriction, statements);
	level = defaultLevel;
	type = "hasValue Violation";
    }
	

    public String getMessage()
    {
	String m = "";
	m += "Resource "+instance+" violates the hasValue restriction on class "+onClass+" for property "+restriction.onProperty+".  ";
	m += "Expected to find at least one statement with value "+restriction.hasValue+".  ";

	return(m);
    }


    /*
    public String getLocation()
    {
	return(getLocation(statements));
    }

    public String getLocationXML()
	throws RDFException
    {
	return(getLocationXML(statements));
    }
    */
}

				 
