// $Id: LiteralExpectedIndication.java,v 1.2 2002/08/05 19:03:09 drager Exp $

package org.daml.validator.indications;

import com.hp.hpl.mesa.rdf.jena.model.*;
import java.util.*;

/**
 * Indication used for typed literals whose value does not match the datatype.
 */
public class LiteralExpectedIndication extends Indication {

    /**
     * The datatype of the typed literal.
     */
    Resource datatype;

    /**
     * The value of the typed literal.
     */
    RDFNode value;

    /**
     * The type and value statements used for the location
     */
    Collection statements;

    public static int defaultLevel = Indication.ERROR;


    /**
     * Constructor function.
     * @param datatype The datatype 
     * @param value    The value
     * @param statements The datatype type and value statements (for location)
     */
    public LiteralExpectedIndication(Resource datatype, RDFNode value, Set statements)
    { 
	super();
	this.datatype = datatype;
	this.value = value;
	this.statements = statements;
	type = "Literal Expected";
	level = defaultLevel;
    }


    public String getMessage()
    {
	String m = "";
	m = "Datatype value "+value+" is not a Literal.";
	return m;
    }
    

    public String getLocation()
    {
	return(getLocation(statements));
    }

    public String getLocationXML()
	throws RDFException
    {
	return getLocationXML(statements);
    }

}
