// $Id: RestrictionIndication.java,v 1.4 2002/08/05 19:03:09 drager Exp $

package org.daml.validator.indications;

import com.hp.hpl.mesa.rdf.jena.model.*;
import java.util.*;

/**
 * Indication used for general restriction violations.
 */
public class RestrictionIndication extends Indication {
    
    /**
     * The restriction being violated
     */
    public org.daml.validator.model.DAMLModelImpl.Restriction restriction;

    /**
     * The instance that violates the restriction
     */
    public org.daml.validator.model.DAMLModelImpl.Node instance;

    /**
     * The instance type to which this restriction applies
     */
    public org.daml.validator.model.DAMLModelImpl.Node onClass;

    /**
     * The collection of statements for this class and property;
     */
    public java.util.Collection statements;

    public static int defaultLevel = Indication.ERROR;

    public RestrictionIndication(org.daml.validator.model.DAMLModelImpl.Node instance,
				 org.daml.validator.model.DAMLModelImpl.Node onClass,
				 org.daml.validator.model.DAMLModelImpl.Restriction restriction,
				 java.util.Collection statements)
    {
	super();
	level = defaultLevel;
	type = "Restriction Violation";
	this.instance = instance;
	this.onClass = onClass;
	this.restriction = restriction;
	this.statements = statements;
    }
	

    public String getMessage()
    {
	String m = "";
	m += "Resource "+instance+" violates the restriction "+restriction.node+" on class "+onClass+" for property "+restriction.onProperty+".  ";
	return(m);
    }

    public String getLocation()
    {
	return(getLocation(statements));
    }

    public String getLocationXML()
	throws RDFException
    {
	//System.out.println(restriction);
	return(getLocationXML(instance)+getLocationXML(restriction.node)+getLocationXML(statements));
    }

}

				 
